module Glosbe::LanguageCode
  extend self

  CODES = {
    "aar"=>"aa",
    "abk"=>"ab",
    "afr"=>"af",
    "aka"=>"ak",
    "alb"=>"sq",
    "sqi"=>"sq",
    "amh"=>"am",
    "ara"=>"ar",
    "arg"=>"an",
    "arm"=>"hy",
    "hye"=>"hy",
    "asm"=>"as",
    "ava"=>"av",
    "ave"=>"ae",
    "aym"=>"ay",
    "aze"=>"az",
    "bak"=>"ba",
    "bam"=>"bm",
    "baq"=>"eu",
    "eus"=>"eu",
    "bel"=>"be",
    "ben"=>"bn",
    "bih"=>"bh",
    "bis"=>"bi",
    "tib"=>"bo",
    "bod"=>"bo",
    "bos"=>"bs",
    "bre"=>"br",
    "bul"=>"bg",
    "bur"=>"my",
    "mya"=>"my",
    "cat"=>"ca",
    "cze"=>"cs",
    "ces"=>"cs",
    "cha"=>"ch",
    "che"=>"ce",
    "chi"=>"zh",
    "zho"=>"zh",
    "chu"=>"cu",
    "chv"=>"cv",
    "cor"=>"kw",
    "cos"=>"co",
    "cre"=>"cr",
    "wel"=>"cy",
    "cym"=>"cy",
    "dan"=>"da",
    "ger"=>"de",
    "deu"=>"de",
    "div"=>"dv",
    "dut"=>"nl",
    "nld"=>"nl",
    "dzo"=>"dz",
    "gre"=>"el",
    "ell"=>"el",
    "eng"=>"en",
    "epo"=>"eo",
    "est"=>"et",
    "ewe"=>"ee",
    "fao"=>"fo",
    "per"=>"fa",
    "fas"=>"fa",
    "fij"=>"fj",
    "fin"=>"fi",
    "fre"=>"fr",
    "fra"=>"fr",
    "fry"=>"fy",
    "ful"=>"ff",
    "geo"=>"ka",
    "kat"=>"ka",
    "gla"=>"gd",
    "gle"=>"ga",
    "glg"=>"gl",
    "glv"=>"gv",
    "grn"=>"gn",
    "guj"=>"gu",
    "hat"=>"ht",
    "hau"=>"ha",
    "heb"=>"he",
    "her"=>"hz",
    "hin"=>"hi",
    "hmo"=>"ho",
    "hrv"=>"hr",
    "hun"=>"hu",
    "ibo"=>"ig",
    "ice"=>"is",
    "isl"=>"is",
    "ido"=>"io",
    "iii"=>"ii",
    "iku"=>"iu",
    "ile"=>"ie",
    "ina"=>"ia",
    "ind"=>"id",
    "ipk"=>"ik",
    "ita"=>"it",
    "jav"=>"jv",
    "jpn"=>"ja",
    "kal"=>"kl",
    "kan"=>"kn",
    "kas"=>"ks",
    "kau"=>"kr",
    "kaz"=>"kk",
    "khm"=>"km",
    "kik"=>"ki",
    "kin"=>"rw",
    "kir"=>"ky",
    "kom"=>"kv",
    "kon"=>"kg",
    "kor"=>"ko",
    "kua"=>"kj",
    "kur"=>"ku",
    "lao"=>"lo",
    "lat"=>"la",
    "lav"=>"lv",
    "lim"=>"li",
    "lin"=>"ln",
    "lit"=>"lt",
    "ltz"=>"lb",
    "lub"=>"lu",
    "lug"=>"lg",
    "mac"=>"mk",
    "mkd"=>"mk",
    "mah"=>"mh",
    "mal"=>"ml",
    "mao"=>"mi",
    "mri"=>"mi",
    "mar"=>"mr",
    "may"=>"ms",
    "msa"=>"ms",
    "mlg"=>"mg",
    "mlt"=>"mt",
    "mon"=>"mn",
    "nau"=>"na",
    "nav"=>"nv",
    "nbl"=>"nr",
    "nde"=>"nd",
    "ndo"=>"ng",
    "nep"=>"ne",
    "nno"=>"nn",
    "nob"=>"nb",
    "nor"=>"no",
    "nya"=>"ny",
    "oci"=>"oc",
    "oji"=>"oj",
    "ori"=>"or",
    "orm"=>"om",
    "oss"=>"os",
    "pan"=>"pa",
    "pli"=>"pi",
    "pol"=>"pl",
    "por"=>"pt",
    "pus"=>"ps",
    "que"=>"qu",
    "roh"=>"rm",
    "rum"=>"ro",
    "ron"=>"ro",
    "run"=>"rn",
    "rus"=>"ru",
    "sag"=>"sg",
    "san"=>"sa",
    "sin"=>"si",
    "slo"=>"sk",
    "slk"=>"sk",
    "slv"=>"sl",
    "sme"=>"se",
    "smo"=>"sm",
    "sna"=>"sn",
    "snd"=>"sd",
    "som"=>"so",
    "sot"=>"st",
    "spa"=>"es",
    "srd"=>"sc",
    "srp"=>"sr",
    "ssw"=>"ss",
    "sun"=>"su",
    "swa"=>"sw",
    "swe"=>"sv",
    "tah"=>"ty",
    "tam"=>"ta",
    "tat"=>"tt",
    "tel"=>"te",
    "tgk"=>"tg",
    "tgl"=>"tl",
    "tha"=>"th",
    "tir"=>"ti",
    "ton"=>"to",
    "tsn"=>"tn",
    "tso"=>"ts",
    "tuk"=>"tk",
    "tur"=>"tr",
    "twi"=>"tw",
    "uig"=>"ug",
    "ukr"=>"uk",
    "urd"=>"ur",
    "uzb"=>"uz",
    "ven"=>"ve",
    "vie"=>"vi",
    "vol"=>"vo",
    "wln"=>"wa",
    "wol"=>"wo",
    "xho"=>"xh",
    "yid"=>"yi",
    "yor"=>"yo",
    "zha"=>"za",
    "zul"=>"zu",
  }.freeze

  def normalize(code)
    return unless code
    code = code.to_s
    CODES[code] || code
  end
end
